#ifndef SUBDIVISION_H
#define SUBDIVISION_H

#include <QtOpenGL>
#include <QOpenGLFunctions_4_3_Core>

#include "mesh.h"

class Subdivision
{
public:
    Subdivision(QOpenGLFunctions_4_3_Core *f);
    ~Subdivision();

    void init();
    Mesh *subdivide(Mesh *mesh);

private:
    struct Input
    {
        GLuint vb_handle;
        QVector<unsigned int> index_buffer;
        QVector<Vertex> vertex_buffer;
    };

    QOpenGLFunctions_4_3_Core *f;
    QOpenGLShaderProgram *edgeShader;

    QOpenGLShaderProgram *initComputeShaderProgram(QString &source);
    void precomputeTables(Input input, QVector<GLuint> &edgeIndices_base,
                          QVector<GLuint> &vertexIndices, QVector<GLuint> &vertexIndicesOffsets);
    void runShader(Input input, QVector<GLuint> &edgeIndices);
};

#endif
